/*
	game.c 
	Proiectarea cu microprocesoare 2013
*/

#include "game.h"

void draw_brick(uint8_t x1, uint8_t y1, uint8_t length, uint8_t height, uint8_t ink)
{
	int x2,y2;
	x2 = x1+length;
	y2=  y1+height;
	//latura orizontala sus
	draw_line(x1, y1, x2, y1,ink);
	//latura verticala stanga
	draw_line(x1,y1,x1,y2,ink);
	//latura verticala dreapta
	draw_line(x2,y1,x2,y2,ink);
	//latura orizontala jos
	draw_line(x1,y2,x2,y2,ink);	

}

void draw_line(uint8_t x1, uint8_t y1, uint8_t x2, uint8_t y2, uint8_t ink)
{
	int i = 0;
	if (x1 == x2) // vertical
	{
		int aux; 
		if (y1 > y2) 
		{
			aux = y1; 
			y1 = y2;
			y2 = aux;
		}
		for (i = y1; i < y2; i++)
			if (ink)
				T6963cSetPixelXY(x1,i);
			else
				T6963cResetPixelXY(x1,i);
	}
	
	if (y1 == y2) // orizontal
	{
		int aux; 
		if (x1 > x2) 
		{
			aux = x1; 
			x1 = x2;
			x2 = aux;
		}
		for (i = x1; i < x2; i++)
			if (ink)
				T6963cSetPixelXY(i, y1);
			else
				T6963cResetPixelXY(i, y1);
	}
}


void draw_pad(uint8_t x, uint8_t y, uint8_t ink)
{
	draw_line(x, y, x+PAD_LENGTH, y,ink);
	draw_line(x+1, y-1, x+PAD_LENGTH-2, y-1,ink);
		draw_line(x+1, y+1, x+PAD_LENGTH-2, y+1,ink);
}
void draw_ball(uint8_t x, uint8_t y, uint8_t ink)
{
	if(ink==1)
	{
		T6963cSetPixelXY(x, y); 
		T6963cSetPixelXY(x+1, y); 
		T6963cSetPixelXY(x+2, y); 
		T6963cSetPixelXY(x-1, y); 
		T6963cSetPixelXY(x-2, y); 

		T6963cSetPixelXY(x, y+1); 
		T6963cSetPixelXY(x+1, y+1); 
		T6963cSetPixelXY(x+2, y+1); 
		T6963cSetPixelXY(x-1, y+1); 
		T6963cSetPixelXY(x-2, y+1); 

		T6963cSetPixelXY(x, y-1); 
		T6963cSetPixelXY(x+1, y-1); 
		T6963cSetPixelXY(x+2, y-1); 
		T6963cSetPixelXY(x-1, y-1); 
		T6963cSetPixelXY(x-2, y-1); 

		T6963cSetPixelXY(x, y-2); 
		T6963cSetPixelXY(x+1, y-2); 
		T6963cSetPixelXY(x-1, y-2); 

		T6963cSetPixelXY(x, y+2); 
		T6963cSetPixelXY(x+1, y+2); 
		T6963cSetPixelXY(x-1, y+2); 
	}
	else
	{
		T6963cResetPixelXY(x, y); 
		T6963cResetPixelXY(x+1, y); 
		T6963cResetPixelXY(x+2, y); 
		T6963cResetPixelXY(x-1, y); 
		T6963cResetPixelXY(x-2, y); 

		T6963cResetPixelXY(x, y+1); 
		T6963cResetPixelXY(x+1, y+1); 
		T6963cResetPixelXY(x+2, y+1); 
		T6963cResetPixelXY(x-1, y+1); 
		T6963cResetPixelXY(x-2, y+1); 

		T6963cResetPixelXY(x, y-1); 
		T6963cResetPixelXY(x+1, y-1); 
		T6963cResetPixelXY(x+2, y-1); 
		T6963cResetPixelXY(x-1, y-1); 
		T6963cResetPixelXY(x-2, y-1); 

		T6963cResetPixelXY(x, y-2); 
		T6963cResetPixelXY(x+1, y-2); 
		T6963cResetPixelXY(x-1, y-2); 

		T6963cResetPixelXY(x, y+2); 
		T6963cResetPixelXY(x+1, y+2); 
		T6963cResetPixelXY(x-1, y+2); 
	}

}
int brick_length, brick_height;
int bricks[MAX_NUM_BRICKS][5];
int num_bricks, remaining_bricks;
int max_brick_ypos;

float xspeed=0, yspeed=0;		// Ball speed
float x, y = 0; 
int win = 0;
float x_pad, y_pad;


void init_game(void)
{
	draw_margins();
	draw_bricks();

	win = 0;
	x = BALL_INITX;
	y = BALL_INITY;

	yspeed = BALL_SPEED;
	xspeed = 0;

	draw_ball(x,y,1);

	x_pad = X1_LIMIT+1;
	y_pad = Y2_LIMIT;
	draw_pad(x_pad , y_pad, 1);
	
	yspeed = BALL_SPEED;

}

void draw_bricks(void)
{
	uint8_t initial_xpos, initial_ypos, space, xpos, ypos;
	space = 2;
	initial_xpos = X1_LIMIT + space;
	initial_ypos = Y1_LIMIT + space;
	brick_length = 22;
	brick_height = 15;
	
	num_bricks = 0;
	
	int i = 0;
	for(i = 0; i < 3; i++) 
	{
		xpos = initial_xpos + i*2;
		ypos = initial_ypos + i*brick_height+i*space;
		do{
		
			draw_brick(xpos, ypos, brick_length, brick_height,1);
			bricks[num_bricks][0] = xpos;
			bricks[num_bricks][1] = ypos;
			bricks[num_bricks][2] = xpos+brick_length;
            bricks[num_bricks][3] = ypos+brick_height;
			bricks[num_bricks][4] = 4;
			xpos += brick_length + space;
			num_bricks++;
			
		}while(xpos < 200);
		
	}
	
	max_brick_ypos = ypos + brick_height;
	remaining_bricks = num_bricks;
}
int check_bricks(int xpos, int ypos) 
{
	uint8_t hit = 0;
	int i = 0;
	
	/* first half of the board */
	if (ypos > max_brick_ypos+2) 
		return 1;
	 
	/* check every brick */
	for (i = 0; i < num_bricks; i++)
	{
		/* if number of shots left are > 0 and ball is inside the margins of the brick */
		if ( bricks[i][4] &&
			(ypos +3 >= bricks[i][1]) && (ypos - 3 <= bricks[i][3]) &&
			(xpos +3 >= bricks[i][0]) && (xpos - 3 <= bricks[i][2]))
		{		
			/* decrease number of shots left */
			if (!--bricks[i][4])
			{
				remaining_bricks--;
				/* erase brick */
				draw_brick(bricks[i][0], bricks[i][1], brick_length, brick_height, 0);				
			}			
			else hit = 1;
		}		
	}
	return 1-hit;
}
int check_pad(float xpos, float ypos, float x_pad, float y_pad)
{
	if (!((xpos >= x_pad) && (xpos <= x_pad + PAD_LENGTH)))
		return -1;
	if (ypos > Y2_LIMIT-2 || ypos < Y2_LIMIT-3)
		return -1;

	return xpos - x_pad;
}
int check_margins(int xpos, int ypos)
{
	/* TODO 3: implementati functia check_margins, 
 	 * care trebuie sa returneze HIT_VERT cand bila 
 	 * loveste marginea de sus, HIT_HORIZ cand bila loveste
 	 * marginile din stanga si dreapta si HIT_LOST cand bila
 	 * loveste marginea de jos 
 	 *
 	 * 0 se returneaza daca nu s-a atins niciuna dintre marginile
 	 * suprafetei de joc */

	return 0;
}



void  draw_margins()
{
	draw_brick(X1_LIMIT,Y1_LIMIT,X2_LIMIT-X1_LIMIT, Y2_LIMIT-Y1_LIMIT,1);
	draw_line(X1_LIMIT, Y2_LIMIT, X2_LIMIT, Y2_LIMIT, 0);
}
